C
C       PROGRAMA EM FORTRAN 77
C       CALCULA O PRODUTO MATRIZ VETOR B=A*X
C       CALCULA A NORMA EUCLIDEANA
c
C       DECLARACAO DAS VARIAVEIS
C
C       N    Ordem do sistema
C       A    Matriz do sistema linear
C       X    Vetor do dominio
C       B    Vetor solucao (imagem)
C
        PARAMETER (M=10)
         REAL*4  A(M,M),B(M),X(M),NORMA,NORMA2
         INTEGER I,J,N
C
C       LEITURA DOS DADOS
C
C       Leitura via arquivo (DADOS.DAT) da seguinte forma
C
C       *           --------->  N
C       * * * * *
C       * * * * *
C       * * * * *   --------->  A
C       * * * * *
C       * * * * *
C
C       * * * * *   --------->  X
C
C     EXEMPLO
C
C 4
C 2 -1  0  0
C-1  2 -1  0
C 0 -1  2 -1
C 0  0 -1  2
C 1  1  1  1
C
C
C     Resultados ficarao no arquivo de saida: SOLUCAO1.DAT
C
        OPEN(UNIT=55, FILE= 'DADOS.DAT',STATUS='OLD')
        READ(55,*) N
        DO 10 I=1,N
        READ(55,*) (A(I,J) , J=1,N)
10      CONTINUE
        READ(55,*) (X(I) , I=1,N)
        CLOSE(UNIT=55)

C
        OPEN(UNIT=6, FILE= 'SOLUCAO1.DAT',STATUS='unknown')
C
        WRITE(6,195)
195     FORMAT(//, '  <<<<<  DADOS DE ENTRADA >>>>>')
        WRITE(6,200)
200     FORMAT(///,'   MATRIZ  DADA  ',/)
        DO 20 I=1,N
        WRITE(6,*) (A(I,J) , J=1,N)
20      CONTINUE
        WRITE(6,220)
220     FORMAT(//,'  VETOR X',/)
        WRITE(6,*) (X(I) , I=1,N)
C
C         EXECUCAO
C============================================
        CALL MATRIZVETOR(A,X,B,N,M)
C---------------------------------------------
         NORMA2 = NORMA(B,N)
C=============================================
c
C       IMPRESSAO DOS RESULTADOS
C
        WRITE(6,310)
310     FORMAT(//,'  ********** RESULTADOS  **********  ',/)
        WRITE(6,320)
320     FORMAT(//,'  SOLUCAO   ',/)
        DO 55 I=1,N
        WRITE(6,330) I,B(I)
330     FORMAT(' B(',I2,') = ',F9.5)
55      CONTINUE
        WRITE(6,340) NORMA2
340     FORMAT(//,' NORMA DO VETOR B --> ',F9.6,//)
C
        CLOSE(UNIT=6)
        STOP
        END
C
C ===========  FINAL DO PROGRAMA PRINCIPAL =================
C
C
C========================================================
C       SUBROTINA MATRIZ * VETOR
C--------------------------------------------------------
        SUBROUTINE MATRIZVETOR(A,X,B,N,M)
C
C       DECLARACAO DAS VARIAVEIS
C
C       A,B,X,N         O mesmo do programa principal
C
        REAL*4 A(M,M),B(M),X(M)
        INTEGER I,J,N,m
C
        DO 30 I=1,N
        B(I)=0.
        DO 40 J=1,N
        B(I)=B(I)+A(I,J)*X(J)
40      CONTINUE
30      CONTINUE
C
        RETURN
        END

C=====================================
C       N O R M A  (euclideana)
C-------------------------------------
       REAL * 4 FUNCTION  NORMA(R,N)
c
C      DECLARACAO DAS VARIAVEIS
c
       REAL * 4  R(1),SOMA
C
       SOMA = 0
       DO I = 1,N
          SOMA = SOMA + R(I)*R(I)
       END DO
       NORMA = SQRT(SOMA)
C
       RETURN
       END
C======================================
